# -*- coding: utf-8 -*-
"""HDF5 functions, and utils, and generators, OH MY!"""

from __future__ import annotations

from h5py import AttributeManager, Dataset, File, Group, __version__ as __h5py_version__

from h5.__about__ import __version__
from h5._info import (
    DatasetInfo as DatasetInfo,
    DatasetInfoDict as DatasetInfoDict,
    FileInfo as FileInfo,
    FileInfoDict as FileInfoDict,
    FileInfoDumpDict as FileInfoDumpDict,
    GroupInfo as GroupInfo,
    GroupInfoDict as GroupInfoDict,
    GroupInfoDumpDict as GroupInfoDumpDict,
    info as info,
)
from h5._types import (
    FileOrGroup as FileOrGroup,
    FsPath as FsPath,
    GroupLikeOrFsPath as GroupLikeOrFsPath,
    H5pyCompression as H5pyCompression,
    H5pyDriver as H5pyDriver,
    H5pyMode as H5pyMode,
)
from h5.core import (
    as_h5py_obj as as_h5py_obj,
    attrs as attrs,
    attrs_dict as attrs_dict,
    attrs_gen as attrs_gen,
    attrs_gen_from_fspath as attrs_gen_from_fspath,
    datasets as datasets,
    datasets_dict as datasets_dict,
    datasets_gen as datasets_gen,
    datasets_gen_from_fspath as datasets_gen_from_fspath,
    datasets_keys_list as datasets_keys_list,
    fmt_h5_path as fmt_h5_path,
    groups as groups,
    groups_gen as groups_gen,
    groups_gen_from_fspath as groups_gen_from_fspath,
    groups_keys_list as groups_keys_list,
    h5iter as h5iter,
    h5py_obj_attrs_gen as h5py_obj_attrs_gen,
    h5py_obj_dataset_gen as h5py_obj_dataset_gen,
    h5py_obj_gen as h5py_obj_gen,
    h5py_obj_groups_gen as h5py_obj_groups_gen,
    h5py_obj_keys_gen as h5py_obj_keys_gen,
    is_dataset as is_dataset,
    is_file as is_file,
    is_fspath as is_fspath,
    is_group as is_group,
    is_group_like as is_group_like,
    is_h5py_dataset as is_h5py_dataset,
    is_h5py_file as is_h5py_file,
    is_h5py_group as is_h5py_group,
    is_hdf5 as is_hdf5,
    items as items,
    keys as keys,
    keys_list as keys_list,
)
from h5.legacy import (
    h5_attrs_dict as h5_attrs_dict,
    h5_attrs_gen as h5_attrs_gen,
    h5_attrs_gen_from_fspath as h5_attrs_gen_from_fspath,
    h5_datasets_dict as h5_datasets_dict,
    h5_datasets_gen as h5_datasets_gen,
    h5_datasets_gen_from_fspath as h5_datasets_gen_from_fspath,
)

__all__ = (
    "AttributeManager",
    "Dataset",
    "DatasetInfo",
    "DatasetInfoDict",
    "File",
    "FileInfo",
    "FileInfoDict",
    "FileInfoDumpDict",
    "FileOrGroup",
    "FsPath",
    "Group",
    "GroupInfo",
    "GroupInfoDict",
    "GroupInfoDumpDict",
    "GroupLikeOrFsPath",
    "H5pyCompression",
    "H5pyDriver",
    "H5pyMode",
    "__h5py_version__",
    "__version__",
    "as_h5py_obj",
    "attrs",
    "attrs_dict",
    "attrs_gen",
    "attrs_gen_from_fspath",
    "datasets",
    "datasets_dict",
    "datasets_gen",
    "datasets_gen_from_fspath",
    "datasets_keys_list",
    "fmt_h5_path",
    "groups",
    "groups_gen",
    "groups_gen_from_fspath",
    "groups_keys_list",
    "h5_attrs_dict",
    "h5_attrs_gen",
    "h5_attrs_gen_from_fspath",
    "h5_datasets_dict",
    "h5_datasets_gen",
    "h5_datasets_gen_from_fspath",
    "h5iter",
    "h5py_obj_attrs_gen",
    "h5py_obj_dataset_gen",
    "h5py_obj_gen",
    "h5py_obj_groups_gen",
    "h5py_obj_keys_gen",
    "info",
    "is_dataset",
    "is_file",
    "is_fspath",
    "is_group",
    "is_group_like",
    "is_h5py_dataset",
    "is_h5py_file",
    "is_h5py_group",
    "is_hdf5",
    "items",
    "keys",
    "keys_list",
)
